<?php

// Id used to identify this page within functions.
$PageID = "BOOK_INFO";

require_once "common.inc";

require_once "config.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "layout.inc";
require_once "search.inc";
require_once "language.inc";
require_once "MARC.inc";
require_once "mgmnt.inc";

if(!isset($_REQUEST['book_control_number']) || $_REQUEST['book_control_number'] == "")
{
	header("Location: search.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth']);
}

if(isset($_REQUEST['show']) && $_REQUEST['show'] == 'marc')
{
	$position = '1';
	$criteria = '001';
	$hits_per_page = 1;
	$url = (isset($_REQUEST['url'])) ? $_REQUEST['url'] : '';
	$_REQUEST['element'] = "F";

	list($YAZ_items, $hits, $MARC) = search($criteria, $_REQUEST['book_control_number'], $position, $hits_per_page, $url, "string");
	
	print "<pre>".$MARC[0]."</pre>";
	
	print '<br /><br /><input type="button" value="'.$langText['BUTTON_CLOSE'].'" class="button" onClick="javascript:window.close();">';
	exit;
}

layout_header();

if(isset($_REQUEST['comment']) || isset($_REQUEST['grade']))
{
	$ok = array();
	$error = array();

	if (isset($_REQUEST['comment']) && $_REQUEST['comment'] != "")
	{
		if(isset($_REQUEST['anonymous_post']) && $_REQUEST['anonymous_post'] == 'on') {
			$user_id = 0;
		} else {
			$user_id = USER_ID;
		}
		
		$res = mysql_query("INSERT INTO comments SET
								comment_book_control_no=".$_REQUEST['book_control_number'].",
								comment_user_id=".$user_id.",
								comment_text='".$_REQUEST['comment']."',
								comment_timestamp=NOW()");

		if(mysql_affected_rows()) {
			array_push($ok, $langText['COMMENT']);
		}
		else {
			array_push($error, $langText['COMMENT']);
		}
	}

	if(isset($_REQUEST['grade']) && is_numeric($_REQUEST['grade']))
	{
		$res = mysql_query("INSERT INTO grades SET
								grade_book_control_no=".$_REQUEST['book_control_number'].",
								grade_number=".$_REQUEST['grade']);

		if(mysql_affected_rows()) {
			array_push($ok, $langText['GRADE']);
		}
		else {
			array_push($error, $langText['GRADE']);
		}
	}

	//make into function at some point
	$tmp = array('ok' => $ok, 'error' => $error);
	$title = '';

	foreach ($tmp as $key => $values)
	{
		//$title .= '<font class="' . $key .'">';
		$tmpstr = '';

		switch (sizeof($values))
		{
			case 2:
				$tmpstr .= 	$values[0] . ' ' .
							$langText['AND'] . ' ' .
							$values[1] . ' ' .
							$langText['ADDED_' . strtoupper($key) . '_PLURAL'] . ' ';
				break;

			case 1:
				$tmpstr .= 	$values[0] . ' ' .
							$langText['ADDED_' . strtoupper($key) . '_SINGULAR'] . ' ';
				break;

			default:
				break;
		}

		$title .= ucfirst(strtolower($tmpstr));
		//$title .= '</font>';
	}

	$class = (empty($error)) ? 'ok' : 'error';
	layout_page_title($title, $class);

	//do not want to include this variable, if present through the use of REQUEST_URI
	unset($_REQUEST['reserve']);
}

if(isset($_REQUEST['reserve']) && isset($_REQUEST['book_id']))
{
	$res = mysql_query("SELECT * FROM books WHERE book_id=".$_REQUEST['book_id']);

	if(mysql_num_rows($res))
	{
    	$row = mysql_fetch_array($res);

		if($row['book_borrowed'] == 1)
		{
			$borrowed = mysql_fetch_array(mysql_query("SELECT * FROM borrowed WHERE borrowed_book_id=".$_REQUEST['book_id']));

        	if($row['book_reserved'] == 0 && $borrowed['borrowed_user_id'] != USER_ID)
			{
				$res = mysql_query("UPDATE books SET book_reserved=1 WHERE book_id=".$_REQUEST['book_id']);
				$res_ = mysql_query("INSERT INTO reservations SET reserve_book_id=".$_REQUEST['book_id'].", reserve_user_id=".USER_ID.", reserve_date=NOW()");

				if(mysql_affected_rows())
					layout_page_title($langText['RESERVE_SUCCESS'], 'ok');
				else
					layout_page_title($langText['ERROR_RESERVE'], 'error');
			}
			elseif($borrowed['borrowed_user_id'] == USER_ID)
			{
				layout_page_title($langText['ERROR_IDENTICAL_BORROWER'], 'error');
			}
			else
			{
				layout_page_title($langText['ERROR_RESERVED'], 'error');
			}

		}
		else
		{
			layout_page_title($langText['ERROR_NOT_BORROWED'], 'error');
		}
	}
	else
		layout_page_title($langText['ERROR_NO_BOOK'], 'error');
}

layout_page_title();

if(!isset($_REQUEST['url']) || $_REQUEST['url'] == $config['zebra_host'].":".$config['zebra_port']."/".$config['zebra_db'])
{
	print '
		<table cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td align="left" valign="top">
	';
}

$position = '1';
$criteria = '001';
$hits_per_page = 1;
$url = (isset($_REQUEST['url'])) ? $_REQUEST['url'] : '';
$_REQUEST['element'] = "F";

//list($YAZ_items, $hits) = search($criteria, $_REQUEST['book_control_number'], $position);
list($YAZ_items, $hits) = search($criteria, $_REQUEST['book_control_number'], $position, $hits_per_page, $url);

$i = 0;
while($i < $hits && $hits <= 10) //Question: Can there be more than 1 hit??
{
	$headers = array();
	$content = array();

	parseMARC($YAZ_items[$i]);
	$row = createMARCRow(return_with_format_syntax($MARC_display_extended));

	$header = (strlen($row['book_title']) > 50) ? substr($row['book_title'], 0, 47) . '...' : $row['book_title'];
	$headers = array($header);
	layout_table_header($headers, array('colspan="2"'), '', 'width="100%"');

	while(list($key, $value) = each($row))
	{
		//array_push($content, $row[$key], "&nbsp;");
		layout_table_row(array('<b>' . $langText[strtoupper($key)] . '</b>', $row[$key]));
	}

	$i++;

	layout_table_footer();
}

print '<br />';

$sql = "SELECT * FROM books WHERE book_control_number=" . $_REQUEST['book_control_number'] . " ORDER BY book_borrowed ASC, book_id ASC";
$sqlResult = mysql_query($sql);

if(mysql_num_rows($sqlResult))
{
	$headers = array();
	$content = array();

	if(check_priv("DELETE")) {
		array_push($headers, "&nbsp;");
	}

	array_push($headers, "&nbsp;", $langText['BOOK_ID'], $langText['BOOK_LOCATION'], $langText['BOOK_SHELF_NO'], $langText['BOOK_STATUS'], $langText['BOOK_MESSAGE']);

	layout_table_header($headers, array(), '', 'width="100%"');

	while($row = mysql_fetch_array($sqlResult))
	{
		$content = array();

		$sql_ = "SELECT location_name FROM locations WHERE location_id=".$row['book_location'];
		$sqlResult_ = mysql_query($sql_);
		$row_ = mysql_fetch_array($sqlResult_);

		$expiry = mysql_fetch_array(mysql_query("SELECT UNIX_TIMESTAMP(borrowed_date), borrowed_user_id FROM borrowed WHERE borrowed_book_id=".$row['book_id']));
		list($date, $epoch) = expiry_date($expiry['UNIX_TIMESTAMP(borrowed_date)']);

		$class = 'auto';

		if(!isset($row['book_shelf_no']))
			$row['book_shelf_no'] = "-";

		if(!isset($row['book_message']))
			$row['book_message'] = "";

		if($row['book_borrowed'] == '0') {
			$status = $langText['BOOK_IN'];
		}
		elseif($epoch > time()) {
			$status = $langText['BOOK_EXPIRY'].": ".$date;
			$class = array(1,2);
		}
		else
		{
         	$status = "<font class='underline'>".$langText['BOOK_EXPIRED'].": ".$date."</font>";
//			$row['book_message'] .= " (".$langText['BOOK_LATE'].")";
			$class = array(3,4);
		}

		if($row['book_reserved'] == 1)
			$row['book_message'] .= " ".$langText['RESERVED'];

		if(check_priv("DELETE") && $row['book_borrowed'] == 0 && $row['book_reserved'] == 0) {
			array_push($content, "<a href='book_delete.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&book_id=" . format_book_id($row['book_id']) . "'>" . layout_insertImg('icon_delete.png') . "</a>");
		} else {
			array_push($content, '&nbsp;');
		}

		if($row['book_borrowed'] == 1 && $row['book_reserved'] == 0 && $expiry['borrowed_user_id'] != USER_ID)
		{
			$url = (isset($_REQUEST['url'])) ? $_REQUEST['url'] : '';
     		if(isset($_REQUEST['search_criteria']) && isset($_REQUEST['search_query']) && isset($_REQUEST['search_position']))
			{
				array_push($content, 	"<a href='book_info.php?id=".$_REQUEST['id']
											."&auth=".$_REQUEST['auth']
											."&url=".$url
											."&book_control_number=".$_REQUEST['book_control_number']
											."&search_criteria=".$_REQUEST['search_criteria']
											."&search_query=".$_REQUEST['search_query']
											."&search_position=".$_REQUEST['search_position']
											."&search_location=".$_REQUEST['search_location']
											."&exact_query=".$_REQUEST['exact_query']
											."&book_id=".$row['book_id']
											."&reserve=1'>".layout_insertImg('icon_reserve_book.png')
										."</a>");
			}
			else
   			{
				array_push($content, 	"<a href='book_info.php?id=".$_REQUEST['id']
											."&auth=".$_REQUEST['auth']
											."&url=".$url
											."&book_control_number=".$_REQUEST['book_control_number']
											."&book_id=".$row['book_id']
											."&reserve=1'>".layout_insertImg('icon_reserve_book.png')
										."</a>");
			}
		}
		else
			array_push($content, "&nbsp;");

		array_push($content, format_book_id($row['book_id']), $row_['location_name'], $row['book_shelf_no'], $status, $row['book_message']);

		layout_table_row($content, $class);

		$i++;

	}

	layout_table_footer();

	print '<br />';

	if(isset($_REQUEST['search_criteria']) && isset($_REQUEST['search_query']) && isset($_REQUEST['search_position']))
	{
		$url = (isset($_REQUEST['url'])) ? $_REQUEST['url'] : '';
		
		$back_button = 	"<input type='button' class='button' value='&lt;&lt;&nbsp;" . $langText['BUTTON_BACK'] .
						"' onClick='location.href=\"search.php?id=" . $_REQUEST['id'] .
						"&auth=" . $_REQUEST['auth'] .
						"&criteria=" . $_REQUEST['search_criteria'] .
						"&query=" . $_REQUEST['search_query'] .
						"&position=" . $_REQUEST['search_position'] .
						"&url=".$url .
						"&location=".$_REQUEST['search_location'] .
						"&exact_query=".$_REQUEST['exact_query'];

		if (isset($_REQUEST['in_shelf'])) $back_button .= "&in_shelf";
		if (isset($_REQUEST['not_reserved'])) $back_button .= "&not_reserved";

		$back_button .=	"\"'>";

		print $back_button;

				?> &nbsp;<input type="button" class="button" value="<?php echo $langText['BUTTON_SHOW_MARC']?>" onClick='javascript:window.open("<?php echo getenv('REQUEST_URI') ?>&show=marc","marc_window","toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizeable=no, copyhistory=no, width=500, height=600")'> <?php
	}
	else
	{
		print "<input type='button' class='button' value='&lt;&lt;&nbsp;".$langText['BUTTON_BACK']."'
				onClick='javascript:history.go(-1)'>";
	
				?> &nbsp;<input type="button" class="button" value="<?php echo $langText['BUTTON_SHOW_MARC']?>" onClick='javascript:window.open("<?php echo getenv('REQUEST_URI') ?>&show=marc","marc_window","toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizeable=no, copyhistory=no, width=500, height=600")'> <?php
	}
	
	$row = mysql_fetch_array(mysql_query(	"SELECT TRUNCATE(AVG(grade_number),1) AS average FROM grades WHERE grade_book_control_no=".$_REQUEST['book_control_number']." GROUP BY grade_book_control_no"));

	?>

	</td>
	<td width="30">&nbsp;</td>
	<td align="left" valign="top">

		<?php layout_page_info($langText['GRADE_BOOK'])?>
		<form name='grade_comment' action='<?php echo getenv('REQUEST_URI') ?>' method='post'>
		<input type="hidden" name="id" value="<?php echo $_REQUEST['id'] ?>">
		<input type="hidden" name="auth" value="<?php echo $_REQUEST['auth'] ?>">

		<table cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td align="left" valign="top">

					<table cellspacing="0" cellpadding="0" border="0">
						<tr>
							<td align="center">4</td>
							<td align="center">5</td>
							<td align="center">6</td>
							<td align="center">7</td>
							<td align="center">8</td>
							<td align="center">9</td>
							<td align="center">10</td>
						</tr>
						<tr>
							<td align="center"><input type='radio' name='grade' value=4></td>
							<td align="center"><input type='radio' name='grade' value=5></td>
							<td align="center"><input type='radio' name='grade' value=6></td>
							<td align="center"><input type='radio' name='grade' value=7></td>
							<td align="center"><input type='radio' name='grade' value=8></td>
							<td align="center"><input type='radio' name='grade' value=9></td>
							<td align="center"><input type='radio' name='grade' value=10></td>
						</tr>

					</table>

				</td>
				<td width="20">&nbsp;</td>
				<td align="left" valign="top">

					<font class="grade-average"><?php echo $row['average'] ?></font>
					<br />
					<font class="tiny">
						<span class="grey"><?php echo $langText['CURRENT_AVERAGE'] ?></span>
					</font>

				</td>
			</tr>

		</table>


		<?php layout_page_info($langText['COMMENT_BOOK'])?>
		<table cellpadding="0" cellspacing="0" border="0">

			<tr>
		 		<td>
					<textarea class="textarea" name="comment" cols="40" rows="10"></textarea>
				</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td align='right'><?php echo $langText['POST_ANONYMOUSLY']?>:&nbsp;<input type="checkbox" name="anonymous_post"></td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td align='right'>
					<input type="reset" name="reset" value="<?php echo $langText['BUTTON_RESET']?>" class="button">
					&nbsp;&nbsp;
					<input type='submit' name='post' value='<?php echo $langText['BUTTON_POST']?>&nbsp;&gt;&gt;' class='button'>
				</td>
			</tr>

		</table>
		</form>

		<br />

		<?php

		$res = mysql_query(	"SELECT *, UNIX_TIMESTAMP(comment_timestamp) AS epoch_timestamp
							FROM comments
							WHERE comment_book_control_no=".$_REQUEST['book_control_number']."
							ORDER BY comment_timestamp DESC");

		if (mysql_num_rows($res)) {
			print '<hr class="hr-dashed" width="100%">';
			layout_page_info($langText['OTHER_COMMENTS']);
		}
		
		print '<table cellpadding="0" cellspacing="0" border="0" width="100%">';

		while($row = mysql_fetch_array($res))
		{
			if($row['comment_user_id'] == 0) {
				$user_row['user_given_names'] = $langText['ANONYMOUS_GIVEN_NAMES'];
				$user_row['user_surname'] = $langText['ANONYMOUS_SURNAME'];
			} else {
				$user_row = mysql_fetch_array(mysql_query("SELECT * FROM users WHERE user_id=".$row['comment_user_id']));
			}
			?>

			<tr>
				<td colspan="2"><?php echo $langText['POSTED_BY']." <b>".format_user_real_name($user_row)."</b> ".$langText['ON']." ".date(USER_DATE_FORMAT, $row['epoch_timestamp'])?></td>
			</tr>
			<tr>
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td><?php echo nl2br($row['comment_text'])?></td>
			</tr>
			<tr>
				<td colspan="2">&nbsp;</td>
			</tr>
			<tr>
				<td colspan="2"><hr class='hr' width='100%'></td>
			</tr>

			<?php
		}

		?>

		</td>
		<td width="30">&nbsp;</td>
	</tr>
	</table>

	</table>

	<?php
}
else
{
	print '<br />';

	if(isset($_REQUEST['search_criteria']) && isset($_REQUEST['search_query']) && isset($_REQUEST['search_position']))
	{
		print 	"<input type='button' class='button' value='&lt;&lt;&nbsp;" . $langText['BUTTON_BACK'] .
				"' onClick='location.href=\"search.php?id=" . $_REQUEST['id'] .
				"&auth=" . $_REQUEST['auth'] .
				"&criteria=" . $_REQUEST['search_criteria'] .
				"&query=" . $_REQUEST['search_query'] .
				"&position=" . $_REQUEST['search_position'] .
				"&url=".$_REQUEST['url'] .
				"\"'>";
	}
	else
	{
		print "<input type='button' class='button' value='&lt;&lt;&nbsp;".$langText['BUTTON_BACK']."'
				onClick='javascript:history.go(-1)'>";
	}

}

layout_footer();

?>
