<?php

// Id used to identify this page within functions.
$PageID = "PDF";

require_once "sessions.inc";
session_verify("no verification");

require_once "language.inc";
parseLang();

require_once "privpref.inc";
require_once "error.inc";

if (!check_priv("ENABLE"))
{
	error("account disabled");
	exit;
}

// Check privileges defined in page_config.
if (!has_page_priv())
{
	error("no priv");
	exit;
}

require_once "config.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "language.inc";
require_once "layout.inc";
require_once "MARC.inc";
require_once "search.inc";
require_once "mgmnt.inc";

parseLang();

if(isset($_REQUEST['page']) && $_REQUEST['page'] == "statistics")
{
	$PageID = "STATS";
	parseLang();

	$sql = "SELECT book_borrow_count, book_control_number FROM books WHERE book_borrow_count!=0 ORDER BY book_borrow_count DESC";
	$sqlResult = mysql_query($sql);

	if(!mysql_num_rows($sqlResult))
	{
		layout_page_title($langText['NOTHING_BORROWED']);
	}
	else
	{
		layout_page_title($langText['TOP_TEN_HEADER']);

		$headers = array($langText['RANKING'],$langText['BORROW_COUNT']);

		foreach ($MARC_display_in_list as $value)
		{
			array_push($headers, $langText[strtoupper($MARC_config[$value])]);
		}

		?>

		<table cellpadding=5 cellspacing=0 border=1>
			<tr>

		<?php

        foreach($headers as $hd)
		{
			print "<td><b>".$hd."</b></td>";
		}

        ?>

			</tr>

		<?php

		$i = 0;
		$rows = array();

		while(($row = mysql_fetch_array($sqlResult)) && $i < 100)
		{
			if(array_key_exists($row['book_control_number'], $rows))
				$rows[$row['book_control_number']]['book_borrow_count'] += $row['book_borrow_count'];
			else
				$rows[$row['book_control_number']] = $row;
			$i++;
		}

		$i = 0;
		foreach($rows as $row)
		{
			$i++;

			//print_r($row);

			print "<tr><td>".$i."</td><td>".$row['book_borrow_count']."</td>";

			if ($i >= 10)
				break;

			$content = array($i, "&nbsp;", $row['book_borrow_count'], "&nbsp;");

			$_REQUEST['element'] = "F";
			list($YAZ_items, $hits) = search("001", format_control_number($row['book_control_number']), "1");
			parseMARC($YAZ_items[0]);

			$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));

			foreach ($row as $key => $value)
			{
				print "<td>".$value."</td>";
			}

			print "</tr>";
		}


		?>

		</table>

		<?php
	}
}
elseif(isset($_REQUEST['page']) && $_REQUEST['page'] == "user_list")
{
	if(isset($_REQUEST['group_id']) && is_numeric($_REQUEST['group_id']) && is_group_manager($_REQUEST['group_id']))
	{
    	$group_info = mysql_fetch_array(mysql_query("SELECT group_name FROM groups WHERE group_id=".$_REQUEST['group_id']));

    	$res = mysql_query(	"SELECT *
							FROM users,linkage
							WHERE users.user_id=linkage.user_id && linkage.group_id=".$_REQUEST['group_id']." && linkage.visible=1
							ORDER BY user_surname ASC");

		if(!mysql_num_rows($res))
		{
			layout_page_title($langText['ERROR_NO_GROUP']);
		}
		else
		{
			layout_page_title("<b>".$langText['USER_LIST_FOR']." ".$group_info['group_name']."</b>");

			$headers = array("&nbsp;");

			?>

			<table cellpadding=8 cellspacing=0 border=1 width="100%">
				<tr>

			<?php
			
			while($row = mysql_fetch_array($res))
			{
            	if(is_numeric($row['user_name']) && strlen($row['user_password']) != 32)
					$pass = $row['user_password'];
				else
					$pass = '****';

				if($row['user_id'] == $row['user_card_number']) {
                	$card_number = format_card_number($row['user_card_number']);
					$user_name = $card_number;
				} else {
					$card_number = $row['user_card_number'];
					$user_name = $row['user_name'];
				}

				?>	
				
				<tr>
					<td width='100%'>
						<b><?php echo format_user_real_name($row) ?></b>&nbsp;&nbsp;( <?php echo $user_name ?> / <?php echo $pass ?> )
					</td>
					<td align='right'>
						<img src='barcodes/<?php echo $card_number?>.png' border=0>
					</td>
				</tr>
				
				<?php
				
			}
			
			?>
			
			</table>
			
			<?php
		}
	}
	else
		print "ERROR";

}

elseif(isset($_REQUEST['page']) && $_REQUEST['page'] == "view_borrowed")
{
 	if(isset($_REQUEST['group_id']) && is_numeric($_REQUEST['group_id']))
	{
		if(is_group_manager($_REQUEST['group_id']) && view_borrowed_allowed($_REQUEST['group_id']))
		{
			?>

			<table cellpadding=5 cellspacing=0 border=0 width='100%'>

			<?php

			$headers = array($langText['BOOK_ID']);
			foreach ($MARC_display_in_list as $value)
			{
				array_push($headers, $langText[strtoupper($MARC_config[$value])]);
			}


         	$res = mysql_query(	"SELECT *
								FROM users, linkage
								WHERE users.user_id=linkage.user_id && linkage.group_id=".$_REQUEST['group_id']."
								ORDER BY user_surname");

			while($row = mysql_fetch_array($res))
			{

				if(can_view_borrowed($row['user_id']))
				{
					$sql_res = mysql_query(	"SELECT *
											FROM users, books, borrowed
											WHERE users.user_id=borrowed.borrowed_user_id &&
												borrowed.borrowed_book_id=books.book_id &&
												users.user_id=".$row['user_id']);

					?>

	                <tr>
						<td colspan=5><?php echo $langText['BORROWED_BOOKS_FOR']." <b>".format_user_real_name($row)?>:</b></td>
					</tr>
					<tr>
						<td colspan=5>

					<?php

					if(mysql_num_rows($sql_res))
					{
						print "	<table cellpadding=5 cellspacing=0 border=1 width='100%'>
									<tr>";

	       				foreach ($headers as $hd)
						{
							print "<td>".$hd."</td>";
						}

		   	            print "</tr>";

						while ($row_ = mysql_fetch_array($sql_res))
						{

							print "<tr>";
							print "<td>".format_book_id($row_['book_id'])."</td>";
							$_REQUEST['element'] = "F";
							list($YAZ_items, $hits) = search("001", format_control_number($row_['book_control_number']), "1");
							parseMARC($YAZ_items[0]);

							$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));

							foreach ($row as $key => $value)
							{
								print "<td>".$value."</td>";
							}

							print 	"</tr>";
						}

						print "	</table>
							</td>
						</tr>";

					}
					else
					{
						print 	"		- ".$langText['NO_BOOKS_BORROWED']." -</td>
									</tr>";
					}

					print 	"<tr>
								<td colspan=5>&nbsp;</td>
							</tr>";

					}

				}

				?>

				</table>

				<?php

			}

	}
	elseif(isset($_REQUEST['user_id']) && is_numeric($_REQUEST['user_id']))
	{
		$PageID = "VIEW_BORROWED_BOOKS";
		parseLang();

    	$user = mysql_fetch_array(mysql_query("SELECT user_given_names, user_surname FROM users WHERE user_id=".$_REQUEST['user_id']));
		$res = mysql_query("SELECT book_id FROM books WHERE book_id IN (SELECT borrowed_book_id FROM borrowed WHERE borrowed_user_id=".$_REQUEST['user_id'].")");

		if(mysql_num_rows($res))
		{

			$comma_separated_list = "";
			while($sql_row = mysql_fetch_array($res))
			{
				$comma_separated_list .= $sql_row['book_id'].",";
			}

			$comma_separated_list = chop_last($comma_separated_list);

			$headers = array($langText['BOOK_ID']);
			foreach ($MARC_display_in_list as $value)
			{
				array_push($headers, $langText[strtoupper($MARC_config[$value])]);
			}
			array_push($headers, $langText['BOOK_STATUS']);

			list($book_list, $book_ids_only, $books) = zebra_list_syntax($comma_separated_list);

			$_REQUEST['element'] = "F";
			if(count($books) > 1)
				list($YAZ_items, $hits) = search("001", $book_list, "1", count($books), "", "", "@or");
			else
				list($YAZ_items, $hits) = search("001", $book_list, "1");

			$i = 0;
			$hits_inc = 0;
			$old_rows = array();
			$color = 1;
			if($hits)
			{
				print "<h3>".$langText['VIEW_BORROWED_OF'].": ".format_user_real_name($user)."</h3><br>";

				?>

				<table cellspacing=0 cellpadding=5 border=1>
					<tr>

				<?php

   				foreach ($headers as $hd)
				{
					print "<td>".$hd."</td>";
				}

				print "</tr>";

				while($i < count($books))
				{
					$row = array();

					if(array_key_exists($book_ids_only[$i], $old_rows))
					{
						$row = $old_rows[$book_ids_only[$i]];
					}
					else
					{
						parseMARC($YAZ_items[$hits_inc]);
						$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));
						$old_rows[$book_ids_only[$i]] = $row;
						$hits_inc++;
					}

					$content = array(format_control_number($books[$i]).$config['book_id_suffix']);
					while(list($key, $value) = each($row))
					{
						array_push($content, $row[$key]);
					}

					$expiry = mysql_fetch_array(mysql_query("SELECT UNIX_TIMESTAMP(borrowed_date) FROM borrowed WHERE borrowed_book_id=".$books[$i]));
					list($expiry_format, $expiry_epoch) = expiry_date($expiry['UNIX_TIMESTAMP(borrowed_date)']);
					if($expiry_epoch > time())
					{
						$status = $langText['BOOK_EXPIRY'].": ".$expiry_format;
						if($color == 1)
							$color = 2;
						else
							$color = 1;

						array_push($content, $status);
					}
					else
					{
						$status = $langText['BOOK_EXPIRED'].": ".$expiry_format;
						if($color == 3)
							$color = 4;
						else
							$color = 3;
							array_push($content, $status);
					}

                    print "<tr>";

                    foreach($content as $r)
					{
						print "<td>".$r."</td>";
					}

					print "</tr>";

					$i++;

				}
			}

			print "</table>";

		}
		else
			print "<font class='error'>".$langText['NO_BOOKS_BORROWED']."</font>";

	}
	else
		print "ERROR";
}

elseif(isset($_REQUEST['page']) && $_REQUEST['page'] == "print_reminder")
{
	$message = "";

    $loc = mysql_fetch_array(mysql_query("SELECT * FROM locations WHERE location_id=".USER_LOCATION));
	$row = mysql_fetch_array(mysql_query("SELECT * FROM users WHERE user_id=".$_REQUEST['user_id']));

	$res = mysql_query("SELECT *, UNIX_TIMESTAMP(borrowed.borrowed_date) as borrowed_epoch FROM borrowed, books WHERE borrowed.borrowed_book_id=books.book_id && borrowed.borrowed_user_id=".$_REQUEST['user_id']);

	if(mysql_num_rows($res))
	{
		parseLang($row['user_lang']);

		while($book = mysql_fetch_array($res))
		{
			list($expiry_format, $expiry_epoch) = expiry_date($book['borrowed_epoch']);

			if($expiry_epoch < time())
			{

				$_REQUEST['element'] = "F";
				list($YAZ_items, $hits) = search("001", format_control_number($book['book_control_number']), "1");
				parseMARC($YAZ_items[0]);
				$MARCrow = createMARCRow(return_with_format_syntax($MARC_display_in_list));

				$message .= $langText['BOOK_AUTHOR'].": ".$MARCrow['book_author']."<br>";
				$message .= $langText['BOOK_TITLE'].": ".$MARCrow['book_title']."<br>";
				$message .= $langText['BOOK_ID'].": ".format_book_id($book['book_id'])."<br>";
				$message .= $langText['EXPIRED'].": ".$expiry_format."<br>";
				$message .= $langText['BORROWED_DATE'].": ".date($row['user_date_format'], $book['borrowed_epoch'])."<br><br>";
			}
		}

		if($message)
		{

			?>
			<font size=1><?php echo $loc['location_name']?><br>
			<?php echo $loc['location_postal_address']."<br>".$loc['location_postal_code']." ".$loc['location_town']."<br>".$loc['location_phone'].", ".$loc['location_fax']?></font><br><br><br><br><br><br>

			<b><?php echo format_user_real_name($row)?><br>
			<?php echo $row['user_postal_address']?><br>
			<?php echo $row['user_town']." ".$row['user_postal_code']?></b><br><br><br><br><br><br>

			<?php echo $langText['REMINDER_TEXT']?><br><br><br><br>

			<?php echo $message?><br>

			<?php

		}

		parseLang();

	}

}

?>
