<?php

// Id used to identify this page within functions.
$PageID = "PRINT";

require_once "sessions.inc";
session_verify("no verification");

require_once "language.inc";
parseLang();

require_once "privpref.inc";
require_once "error.inc";

if (!check_priv("ENABLE"))
{
        error("account disabled");
        exit;
}

// Check privileges defined in page_config.
if (!has_page_priv())
{
	error("no priv");
	exit;
}

require_once "config.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "language.inc";
require_once "layout.inc";
require_once "MARC.inc";
require_once "search.inc";
require_once "mgmnt.inc";

function to_hex($hex)
{
	return chr(hexdec($hex));
}

function get_breaked($unb, $margin = 0, $size = 0)
{
	switch ($size) {
		case 0:
			$maxcount = 48;
			break;
		case 1:
			$maxcount = 24;
			break;
		case 2:
			$maxcount = 16;
			break;
		case 3:
			$maxcount = 12;
			break;
		case 4:
			$maxcount = 9;
			break;
		case 5:
			$maxcount = 8;
			break;
	}

	$unb = str_replace('\n', ' \n ', $unb);
	$unb = str_replace('[nl]', ' \n ', $unb);

	$maxusable = $maxcount - (2 * $margin);
	$words = explode(" ", $unb);
	$i = 0;
	$cc = $margin;
	$rep = str_repeat(" ", $margin);

	while ($i < count($words))
	{
		if ($words[$i] == '\n')
		{
			$rep .= "\n";

			if ($i < (count($words) - 2)) {
				 $rep .= str_repeat(" ", $margin);
			}

			$cc = $margin;
		}
		elseif (($cc+strlen($words[$i])) >= ($maxusable+$margin))
		{
			$cc = $margin + strlen($words[$i]);
			$rep .= "\n" . str_repeat(" ", $margin) . $words[$i];
		}
		elseif ($cc == $margin)
		{
			$rep .= $words[$i];
			$cc += strlen($words[$i]);
		}
		else
		{
			$rep .= " " . $words[$i];
			$cc += (1 + strlen($words[$i]));
		}
		$i++;
	}

	$rep = str_replace("", "A", $rep);
	$rep = str_replace("", "A", $rep);
	$rep = str_replace("", "O", $rep);
	$rep = str_replace("", "a", $rep);
	$rep = str_replace("", "a", $rep);
	$rep = str_replace("", "o", $rep);
	$rep = str_replace("&Aring;", "A", $rep);
	$rep = str_replace("&Auml;", "A", $rep);
	$rep = str_replace("&Ouml;", "O", $rep);
	$rep = str_replace("&aring;", "a", $rep);
	$rep = str_replace("&auml;", "a", $rep);
	$rep = str_replace("&ouml;", "o", $rep);
	
	return $rep;
}

if (isset($_REQUEST['post_print'])) {
	print "Print operation completed.";
}

if (
	isset($_REQUEST['type'])
	&& $_REQUEST['type'] == "receipt"
	&& isset($_REQUEST['template'])
)
{
	$margin = 5;
	$maxlen = 30; //the maximum length of the author & title fields

	if ($_REQUEST['language'] != USER_LANG)
	{
		$langTmp = $langText;
		parseLang($_REQUEST['language']);
	}

	if ($_REQUEST['template'] == 'user_info')
	{
		print str_repeat(" ", $margin) . to_hex("1b") . to_hex("69") . "11" . $_REQUEST['header'] . to_hex("1b") . to_hex("69") . "00\n\n";
		print get_breaked(	$langText['USER_REAL_NAME'] . ": " . $_REQUEST['real_name'] . '\n' .
							$langText['USER_NAME'] . ": " . $_REQUEST['username'] . '\n' .
							$langText['USER_CARD_NUMBER'] . ": " . $_REQUEST['card_number'] . '\n' .
							$langText['USER_PASSWORD'] . ": " . $_REQUEST['password'] .  '\n\n' .
							$_REQUEST['footer'],
							$margin);

		print to_hex("1b") . to_hex("64") . to_hex("74") . "\n\n" . to_hex("1b") . to_hex("64") . "0";
	}

	elseif ($_REQUEST['template'] == 'borrow')
	{
		$query_books = mysql_query("SELECT * FROM books WHERE books.book_id IN (" . $_REQUEST['old_ids'] . ")");
		$query_borrow = mysql_query("SELECT UNIX_TIMESTAMP(borrowed_date) from borrowed WHERE borrowed.borrowed_book_id IN (" . $_REQUEST['old_ids'] . ")");

		print str_repeat(" ", $margin) . to_hex("1b") . to_hex("69") . "11" . $_REQUEST['header'] . to_hex("1b") . to_hex("69") . "00\n\n";
		print get_breaked(	date($config['dateformat'] . ' ' . $config['timeformat']) . '\n' .
							$langText['LOANER'] . ': ' . $_REQUEST['card_number'] . '\n\n\n' .
							$langText['BORROWED'] . '\n\n',
							$margin);

		while ($book = mysql_fetch_array($query_books))
		{
			$borrow = mysql_fetch_array($query_borrow);

			list($YAZ_items, $hits) = search('001', format_control_number($book['book_control_number']), 1);
			parseMARC(reset($YAZ_items));
			$MARC_row = createMARCRow(return_with_format_syntax($MARC_display_in_list));

			list($formatted_date, $epoch_date) = expiry_date($borrow['UNIX_TIMESTAMP(borrowed_date)'], $_REQUEST['date_format']);

			print get_breaked(	$langText['EXPIRES'] . ': ' . $formatted_date . '\n' .
								format_book_id($book['book_id']) . '\n' .
								substr($MARC_row['book_author'], 0, $maxlen) . '\n' .
								substr($MARC_row['book_title'], 0, $maxlen) . '\n\n',
								$margin);
		}

		print get_breaked('\n' . $_REQUEST['footer'], $margin) .
		to_hex("1b") . to_hex("64") . to_hex("74") . "\n\n" . to_hex("1b") . to_hex("64") . "0";
	}

	elseif ($_REQUEST['template'] == 'return')
	{
		$query = mysql_query("SELECT * FROM books WHERE book_id IN (" . $_REQUEST['old_ids'] . ")");

		print str_repeat(" ", $margin) . to_hex("1b") . to_hex("69") . "11" . $_REQUEST['header'] . to_hex("1b") . to_hex("69") . "00\n\n";
		print get_breaked(	date($config['dateformat'] . ' ' . $config['timeformat']) . '\n\n\n' .
							$langText['RETURNED'] . '\n\n',
							$margin);

		while ($row = mysql_fetch_array($query))
		{
			list($YAZ_items, $hits) = search('001', format_control_number($row['book_control_number']), 1);
			parseMARC(reset($YAZ_items));
			$MARC_row = createMARCRow(return_with_format_syntax($MARC_display_in_list));

			print get_breaked(	format_book_id($row['book_id']) . '\n' .
								substr($MARC_row['book_author'], 0, $maxlen) . '\n' .
								substr($MARC_row['book_title'], 0, $maxlen) . '\n\n',
								$margin);
		}

		print get_breaked('\n' . $_REQUEST['footer'], $margin) .
		to_hex("1b") . to_hex("64") . to_hex("74") . "\n\n" . to_hex("1b") . to_hex("64") . "0";
	}

	if ($_REQUEST['language'] != USER_LANG)
	{
		$langText = $langTmp;
	}
}

if (
	isset($_REQUEST['type'])
	&& $_REQUEST['type'] == "book_label"
)
{
	$row = mysql_fetch_array(mysql_query("SELECT location_name FROM locations WHERE location_id=".USER_LOCATION));

	$ids = explode(",", $_REQUEST['book_id']);
	foreach($ids as $id) {
		print "\nD12\nS2\nq608\nN\nA45,5,0,4,1,1,N,\"" . $row['location_name'] . "\"\nB45,35,0,3,3,6,100,N,\"" . format_book_id($id) . "\"\nA210,145,0,4,1,1,N,\"" . format_book_id($id) . "\"\nP1\n";
	}
}

?>
